"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isValidProviderType = exports.matchProviderType = exports.getProvider = void 0;
var worker = __importStar(require("worker_threads"));
var getProvider = function (_a) {
    var _b, _c, _d;
    var network = _a.network, config = _a.config, dataType = _a.dataType;
    if (((_b = config[network]) === null || _b === void 0 ? void 0 : _b.provider) && matchProviderType(config[network].provider, dataType)) {
        return config[network].provider;
    }
    var providers = (_d = (_c = config[network]) === null || _c === void 0 ? void 0 : _c.providers) === null || _d === void 0 ? void 0 : _d.filter(function (p) { return matchProviderType(p, dataType); });
    if (!(providers === null || providers === void 0 ? void 0 : providers.length)) {
        throw new Error("No configuration found for ".concat(network, " and \"").concat(dataType, "\" compatible dataType"));
    }
    var providerIdx = worker.threadId % providers.length;
    return providers[providerIdx];
};
exports.getProvider = getProvider;
var matchProviderType = function (provider, type) {
    if (!provider) {
        return false;
    }
    if (!type || !provider.dataType || provider.dataType === 'combined') {
        return true;
    }
    // ************  Type match chart  ************************
    // Type       | Array of matched provider.dataType's
    // --------------------------------------------------------
    // realtime   : [ realtime, combined ]
    // historical : [ historical, combined ]
    // combined   : [ combined ]
    // undefined  : [ historical, combined, realtime ]
    if (type === provider.dataType) {
        return true;
    }
    return false;
};
exports.matchProviderType = matchProviderType;
var isValidProviderType = function (expectedType, type) {
    var validTypes = expectedType ? ['combined', expectedType] : ['combined'];
    return validTypes.includes(type);
};
exports.isValidProviderType = isValidProviderType;
//# sourceMappingURL=provider.js.map